org.apache.pdfbox.pdmodel.interactive.form

## Class PDTerminalField

- java.lang.Object
- - org.apache.pdfbox.pdmodel.interactive.form.PDField
  - - org.apache.pdfbox.pdmodel.interactive.form.PDTerminalField

All Implemented Interfaces:
  COSObjectable

Direct Known Subclasses:
  PDButton, PDSignatureField, PDVariableText

    public abstract class PDTerminalField
    extends PDField

A field in an interactive form. Fields may be one of four types: button, text, choice, or signature.

Author:
  sug

### Constructor Summary

Constructors
`protected` `PDTerminalField(PDAcroForm acroForm)` Constructor.

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `applyChange()` Applies a value change to the field.
`int` `getFieldFlags()` This will get the flags for this field.
`String` `getFieldType()` Get the FT entry of the field.
`List<PDAnnotationWidget>` `getWidgets()` Returns the widget annotations associated with this field.
`void` `importFDF(FDFField fdfField)` This will import a fdf field from a fdf document.
`void` `setActions(PDFormFieldAdditionalActions actions)` Set the actions of the field.
`void` `setWidgets(List<PDAnnotationWidget> children)` Sets the field's widget annotations.

### Methods inherited from class org.apache.pdfbox.pdmodel.interactive.form.PDField

`getAcroForm, getActions, getAlternateFieldName, getCOSObject, getFullyQualifiedName, getInheritableAttribute, getMappingName, getParent, getPartialName, getValueAsString, isNoExport, isReadOnly, isRequired, setAlternateFieldName, setFieldFlags, setMappingName, setNoExport, setPartialName, setReadOnly, setRequired, setValue, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### PDTerminalField

    protected PDTerminalField(PDAcroForm acroForm)

Constructor.

Parameters:
  `acroForm` - The form that this field is part of.

### Method Detail

#### setActions

    public void setActions(PDFormFieldAdditionalActions actions)

Set the actions of the field.

Parameters:
  `actions` - The field actions.

#### getFieldFlags

    public int getFieldFlags()

Description copied from class: `PDField`
This will get the flags for this field.

Specified by:
  `getFieldFlags` in class `PDField`
Returns:
  flags The set of flags.

#### getFieldType

    public String getFieldType()

Description copied from class: `PDField`
Get the FT entry of the field. This is a read only field and is set depending on the actual type. The field type is an inheritable attribute.

Specified by:
  `getFieldType` in class `PDField`
Returns:
  The Field type.

#### importFDF

    public void importFDF(FDFField fdfField)
                   throws IOException

Description copied from class: `PDField`
This will import a fdf field from a fdf document.

Parameters:
  `fdfField` - The fdf field to import.
Throws:
  `IOException` - If there is an error importing the data for this field.

#### getWidgets

    public List<PDAnnotationWidget> getWidgets()

Returns the widget annotations associated with this field.

Specified by:
  `getWidgets` in class `PDField`
Returns:
  The list of widget annotations. Be aware that this list is not backed by the actual widget collection of the field, so adding or deleting has no effect on the PDF document until you call `setWidgets()` with the modified list.

#### setWidgets

    public void setWidgets(List<PDAnnotationWidget> children)

Sets the field's widget annotations.

Parameters:
  `children` - The list of widget annotations.

#### applyChange

    protected final void applyChange()
                              throws IOException

Applies a value change to the field. Generates appearances if required and raises events.

Throws:
  `IOException` - if the appearance couldn't be generated